
DROP TABLE libros;
DROP TABLE generos;
DROP TABLE actividad_usuarios;
DROP TABLE codificacion_actividades;
DROP TABLE usuarios_biblioteca;

CREATE TABLE usuarios_biblioteca
( 
  id_usuario               CHAR(15),
  password                 VARCHAR(12), 
  CONSTRAINT pk_usuariosbiblioteca PRIMARY KEY (id_usuario)
);

CREATE TABLE codificacion_actividades
(  
  codigo                   NUMBER,
  descripcion              VARCHAR(50),
  CONSTRAINT pk_codificacionactividades PRIMARY KEY (codigo)
);

CREATE TABLE actividad_usuarios
( 
  fecha_hora               TIMESTAMP,
  id_usuario               CHAR(15),
  ip_cliente               VARCHAR(18), 
  codigo                   NUMBER,
  CONSTRAINT fk_actividad_codificacion FOREIGN KEY (codigo) REFERENCES codificacion_actividades (codigo)  
);

CREATE TABLE generos
(  
  codigo                   CHAR(1),
  descripcion              VARCHAR(32),
  CONSTRAINT pk_generos PRIMARY KEY (codigo)
);

CREATE TABLE libros
(  
  id_libro                 CHAR(5),
  titulo                   VARCHAR(60),
  genero                   CHAR(1),
  fecha_edicion            DATE,
  numero_paginas           NUMBER,
  premiado                 NUMBER,
  CONSTRAINT pk_libros PRIMARY KEY (id_libro),
  CONSTRAINT fk_libros_generos FOREIGN KEY (genero) REFERENCES generos (codigo)  
);


INSERT INTO libros VALUES ('00001','ES UNA FILA A ELIMINAR',NULL,TO_DATE('12-04-1987','DD-MM-YYYY'),890,1);
DELETE FROM libros;
COMMIT;

DROP SEQUENCE secuencia_libros;
CREATE SEQUENCE secuencia_libros MINVALUE 0  START WITH 1;


INSERT INTO usuarios_biblioteca VALUES ('usuario1','password1');
INSERT INTO usuarios_biblioteca VALUES ('usuario2','password2');
INSERT INTO usuarios_biblioteca VALUES ('usuario3','password3');

INSERT INTO codificacion_actividades VALUES (1,'op_menu - Conexion');
INSERT INTO codificacion_actividades VALUES (2,'op_menu - Desconexion');
INSERT INTO codificacion_actividades VALUES (3,'autenticacion');
INSERT INTO codificacion_actividades VALUES (4,'desconectar');
INSERT INTO codificacion_actividades VALUES (5,'op_menu - ConexionEfectuada');
INSERT INTO codificacion_actividades VALUES (6,'op_menu - Volcado a BD');
INSERT INTO codificacion_actividades VALUES (7,'volcarIncidencias');
INSERT INTO codificacion_actividades VALUES (8,'op_menu - Vista Formulario');
INSERT INTO codificacion_actividades VALUES (9,'comboLibros');
INSERT INTO codificacion_actividades VALUES (10,'nuevoLibro');
INSERT INTO codificacion_actividades VALUES (11,'aplicarCambios');
INSERT INTO codificacion_actividades VALUES (12,'eliminarLibro');
INSERT INTO codificacion_actividades VALUES (13,'actualizadoTitulo');
INSERT INTO codificacion_actividades VALUES (14,'actualizadoGenero');
INSERT INTO codificacion_actividades VALUES (15,'actualizadoFechaEdicion');
INSERT INTO codificacion_actividades VALUES (16,'actualizadoNumeroPaginas');
INSERT INTO codificacion_actividades VALUES (17,'actualizadoPremiado');
INSERT INTO codificacion_actividades VALUES (18,'op_menu - Estadisticas Actividad');
INSERT INTO codificacion_actividades VALUES (19,'consultarEstadistica');
INSERT INTO codificacion_actividades VALUES (20,'op_menu - Vista Unica Tabla');
INSERT INTO codificacion_actividades VALUES (21,'reordenar');
INSERT INTO codificacion_actividades VALUES (22,'insertarFila');
INSERT INTO codificacion_actividades VALUES (23,'cancelarInsercionFila');
INSERT INTO codificacion_actividades VALUES (24,'guardarFilaInsertada');
INSERT INTO codificacion_actividades VALUES (25,'eliminarFilaSeleccionada');
INSERT INTO codificacion_actividades VALUES (26,'actualizadaColumnaJTable');
INSERT INTO codificacion_actividades VALUES (27,'op_menu - Vista Paginada Tabla');
INSERT INTO codificacion_actividades VALUES (28,'botonPaginacionAnterior');
INSERT INTO codificacion_actividades VALUES (29,'botonPaginacionSiguiente');
INSERT INTO codificacion_actividades VALUES (30,'botonPaginacionNumerica');
INSERT INTO codificacion_actividades VALUES (31,'op_menu - CierreVentana');
INSERT INTO codificacion_actividades VALUES (32,'op_menu - Vista Arbol');
INSERT INTO codificacion_actividades VALUES (33,'Nuevo nodo');
INSERT INTO codificacion_actividades VALUES (34,'Editar nodo');
INSERT INTO codificacion_actividades VALUES (35,'Eliminar nodo');
INSERT INTO codificacion_actividades VALUES (36,'ratonClicked');
INSERT INTO codificacion_actividades VALUES (37,'cancelarEdicionNodo');
INSERT INTO codificacion_actividades VALUES (38,'op_menu - Configurar Documento');
INSERT INTO codificacion_actividades VALUES (39,'generarPDF');
INSERT INTO codificacion_actividades VALUES (40,'imprimir');
INSERT INTO codificacion_actividades VALUES (41,'copiarAlPortapapeles');

INSERT INTO generos VALUES ('0','Generalidades');
INSERT INTO generos VALUES ('1','Filosofia. Psicologia');
INSERT INTO generos VALUES ('2','Religion. Teologia');
INSERT INTO generos VALUES ('3','Ciencias sociales');
INSERT INTO generos VALUES ('4','No clasificado');
INSERT INTO generos VALUES ('5','Matematicas. Ciencias naturales');
INSERT INTO generos VALUES ('6','Ciencias aplicadas');
INSERT INTO generos VALUES ('7','Bellas artes. Deportes');
INSERT INTO generos VALUES ('8','Literatura');
INSERT INTO generos VALUES ('9','Geografia. Historia');

INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'EL QUIJOTE','8',TO_DATE('12-04-1987','DD-MM-YYYY'),890,1);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'PROGRAMACION ORIENTADA A OBJETOS EN JAVA','0',TO_DATE('11-12-2019','DD-MM-YYYY'),588,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'POESIAS COMPLETAS','8',TO_DATE('18-06-2006','DD-MM-YYYY'),540,1);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'CAMPOS DE CASTILLA','8',TO_DATE('02-04-1995','DD-MM-YYYY'),289,1);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'HAMLET','8',TO_DATE('01-09-1987','DD-MM-YYYY'),452,1);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'FUENTEOVEJUNA','8',TO_DATE('12-11-1973','DD-MM-YYYY'),650,1);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'CUENTOS DE LOS HERMANOS GRIMM','8',TO_DATE('22-04-1990','DD-MM-YYYY'),357,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'LOS IBEROS','9',TO_DATE('05-08-1984','DD-MM-YYYY'),259,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'HISTORIA DE ROMA','9',TO_DATE('12-09-1968','DD-MM-YYYY'),536,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'JULIO CESAR','9',TO_DATE('22-11-2001','DD-MM-YYYY'),380,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'MANUAL DE AUTOAYUDA','1',TO_DATE('22-04-2018','DD-MM-YYYY'),540,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'LA FOTOSINTESIS','5',TO_DATE('30-09-2005','DD-MM-YYYY'),309,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'GENETICA','5',TO_DATE('02-12-2007','DD-MM-YYYY'),519,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'LA CELULA','5',TO_DATE('12-11-2001','DD-MM-YYYY'),648,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'EL SISTEMA LINFATICO','6',TO_DATE('15-04-2005','DD-MM-YYYY'),719,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'EL APARATO DIGESTIVO','6',TO_DATE('12-08-1998','DD-MM-YYYY'),817,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'MANUAL DE FISIOTERAPIA','6',TO_DATE('29-08-2014','DD-MM-YYYY'),790,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'NEUROLOGIA','6',TO_DATE('19-12-2010','DD-MM-YYYY'),583,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'TRAUMATOLOGIA','6',TO_DATE('23-10-2009','DD-MM-YYYY'),490,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'LOS MISERABLES','8',TO_DATE('12-09-1989','DD-MM-YYYY'),590,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'LA VUELTA AL MUNDO EN 80 DIAS','8',TO_DATE('10-04-1985','DD-MM-YYYY'),457,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'LOS TRES MOSQUETEROS','8',TO_DATE('03-04-1981','DD-MM-YYYY'),615,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'VIAJE AL CENTRO DE LA TIERRA','8',TO_DATE('30-04-2000','DD-MM-YYYY'),403,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'HISTORIA DE DOS CIUDADES','8',TO_DATE('12-11-1980','DD-MM-YYYY'),369,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'LA ILIADA','8',TO_DATE('12-04-1987','DD-MM-YYYY'),245,'0');
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'MIGUEL STROGOFF','8',TO_DATE('25-04-2010','DD-MM-YYYY'),481,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'OLIVER TWIST','8',TO_DATE('10-08-1987','DD-MM-YYYY'),340,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'LA ODISEA','8',TO_DATE('03-08-1986','DD-MM-YYYY'),290,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'GUERRA Y PAZ','8',TO_DATE('12-11-1987','DD-MM-YYYY'),810,0);
INSERT INTO libros VALUES (REPLACE(TO_CHAR(secuencia_libros.NEXTVAL,'09999'),' '),'EL LAZARILLO DE TORMES','8',TO_DATE('22-04-1983','DD-MM-YYYY'),358,0);

COMMIT;
