
DROP TABLE votos_emitidos;
DROP TABLE votaciones; 
DROP TABLE titulares;

CREATE TABLE titulares
( codigo                   CHAR(3),
  nombre                   VARCHAR(50), 
  cuota_participacion      NUMBER,
  CONSTRAINT pk_titulares PRIMARY KEY (codigo)
);

CREATE TABLE votaciones
( id_votacion              CHAR(19),           
  tema_votado              VARCHAR(200),
  CONSTRAINT pk_votaciones PRIMARY KEY (id_votacion)
);

CREATE TABLE votos_emitidos
( codigo_titular           CHAR(3),
  id_votacion              CHAR(19),
  opcion_ausente           NUMBER,
  opcion_abstencion        NUMBER,
  opcion_afirmativo        NUMBER,
  opcion_negativo          NUMBER,
  CONSTRAINT pk_votosemitidos PRIMARY KEY (codigo_titular, id_votacion),
  CONSTRAINT fk_votosemitidos_titulares FOREIGN KEY (codigo_titular) REFERENCES titulares (codigo), 
  CONSTRAINT fk_votosemitidos_votaciones FOREIGN KEY (id_votacion) REFERENCES votaciones (id_votacion) 
);


INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES ('001','FILA A ELIMINAR',2.879);
DELETE FROM titulares;
COMMIT;

DROP SEQUENCE secuencia_titulares;
CREATE SEQUENCE secuencia_titulares MINVALUE 0  START WITH 1;


INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ALARCON LAGUNA, CONCEPCION',1.143);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ALPUENTE CARRASCO, VICENTA',1.480);
INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'APARISI  SERRANO, FELIX',0.937);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'BARBERA SORIANO, RAMON',1.238);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'BLANCO ALAMAN, PILAR',1.012);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'BOLUMAR GASCO, ESTRELLA',1.239);
INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'BUENAVENTURA SANCHEZ, ANTONIO',1.085);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'CALATRAVA CARBONELL, TOMAS',0.871);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'CALVO SERRANO, ANGELES',1.520);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'CARABELLA CALVO, BLANCA',1.135);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'CARBO NAVARRO, SANTIAGO',1.305);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'CARRETERO RUS, ANTONIO',0.869);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'CATALA PARDO, CECILIA',1.315);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'DELGADO MARTIN, FRANCISCO MIGUEL',1.873);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ESTEBAN MARTINEZ, MANUEL',0.968);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'FERRERO BOTELLA, FEDERICO',0.732);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'FONTALES ROMEU, INMACULADA',1.354);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'GALIANA MONSALVE, AGUSTIN',1.982);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'GALLEGO GONZALEZ, YOLANDA',2.105);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'GALLEGO LASTRA, FERNANDO',2.098);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'GARCIA JIMENEZ, DOLORES',1.129);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'GIMENEZ OLIVARES, EDUARDO',0.879);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'GOMEZ MARTINEZ, AURORA',1.930);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'GUTIERREZ SOTO, ALVARO',1.459);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'HERRERA BALUARTE, OSCAR',1.380);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'HUERTA CASTELLO, ARTURO',2.390);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'IBARRA PARDO, LUIS',1.814);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ISERTE PARDO, BEATRIZ',1.590);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'JIMENEZ JIMENEZ, LUCAS',2.349);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'JULVE REVERTER, SANTIAGO',1.650);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'LIBERTO REVERTER, ARMANDO',1.895);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'LLOPIS HERNANDEZ, ENRIQUE',2.053);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'LUJAN TORREGROSA, RAMON',1.270);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'MAEZTU AMORES, JUAN',2.983);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'MARTINEZ CLIMENT, CESAR',1.579);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'MERLOS PASCUAL, ISABEL',1.809);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'MINGUEZ FONTALES, SERGIO',0.928);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'MONRRABAL ARIO, SANTIAGO',0.835);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'MORENO CASTILLO, MARCOS',2.558);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'MORILLAS SALVADOR, ANGEL',1.207);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'MUOZ SANCHIS, VICTOR',0.893);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ORDINAS SUAREZ, PEDRO',2.008);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ORIOLA CASTELLO, ANA MARIA',1.901);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'OSUNA PORTOLES, EUGENIO',2.254);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'PEREZ CRESPO, GONZALO',0.908);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'PEREZ RAMON, EUGENIO',0.945);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'PERIS ALBELDA, ALBERTO',1.703);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'RAMIREZ SANCHEZ, ROSARIO ',1.308);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'RAMS SANTAMARIA, GLORIA',0.850);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'RAUSELL MARTIN, VIRGINIA',1.589);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'RODRIGO QUEVEDO, JULIAN',0.980);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'RODRGUEZ SANTOS, VALERIO',0.802);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ROIG GUILLOT, MARIA LUISA',2.190);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ROMERO TAMARIT, PAULA',1.578);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'SANCHEZ PUERTAS, JOSE',1.759);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'SOLIVAS VALIENTE, MIGUEL ANGEL',0.845);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'SORIANO LLOPIS,EMILIO',2.015);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'SORIANO SAINZ, JOSE MANUEL',1.798);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'TEJEDOR LAGUNA, VICENTE',1.890);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'TELLO JOVER, TERESA',2.154);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'UMBERT MORENO, FELISA',1.350);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'VELA ASENSI, SIXTO',2.057);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'VILLALBA ALVAREZ, ALFONSO',0.859);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'VILLAREJO GOMEZ, JORGE',1.250);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'VIVES FONTANA, JOAQUIN',1.803);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ZAPATERO MARCO, SALVADOR',0.905);

INSERT INTO titulares (codigo,nombre,cuota_participacion) VALUES (REPLACE(TO_CHAR(secuencia_titulares.NEXTVAL,'099'),' '),'ZARAGOZA ASENSI, ROSA',1.458);


COMMIT;
